• Codeforces Round #460 (Div. 2)


    A. Supermarket
    We often go to supermarkets to buy some fruits or vegetables, and on the tag there prints the price for a kilo. But in some supermarkets, when asked how much the items are, the clerk will say that a yuan for b kilos (You don't need to care about what "yuan" is), the same as a / b yuan for a kilo.

    Now imagine you'd like to buy m kilos of apples. You've asked n supermarkets and got the prices. Find the minimum cost for those apples.

    You can assume that there are enough apples in all supermarkets.

    Input

    The first line contains two positive integers n and m (1 ≤ n ≤ 5 000, 1 ≤ m ≤ 100), denoting that there are n supermarkets and you want to buy m kilos of apples.

    The following n lines describe the information of the supermarkets. Each line contains two positive integers a, b (1 ≤ a, b ≤ 100), denoting that in this supermarket, you are supposed to pay a yuan for b kilos of apples.

    Output

    The only line, denoting the minimum cost for m kilos of apples. Please make sure that the absolute or relative error between your answer and the correct answer won't exceed 10 - 6.

    Formally, let your answer be x, and the jury's answer be y. Your answer is considered correct if .

    Examples
    input
    3 5
    1 2
    3 4
    1 3
    output
    1.66666667
    input
    2 1
    99 100
    98 99
    output
    0.98989899
    Note

    In the first sample, you are supposed to buy 5 kilos of apples in supermarket 3. The cost is 5 / 3 yuan.

    In the second sample, you are supposed to buy 1 kilo of apples in supermarket 2. The cost is 98 / 99 yuan.

    找最便宜的超市买东西即可。

    #include <bits/stdc++.h>
    
    using namespace std;
    
    int main()
    {
    
        int n;
        double m;
        scanf("%d%lf",&n,&m);
    
        double minx = 0x3f3f3f3f;
        for(int i = 0; i < n; i++) {
            double a,b;
            scanf("%lf%lf",&a,&b);
            minx = min(minx,a/b);
        }
    
        printf("%lf
    ",m*minx);
    
    
        return 0;
    }
    View Code
    B. Perfect Number

    We consider a positive integer perfect, if and only if the sum of its digits is exactly 10. Given a positive integer k, your task is to find the k-th smallest perfect positive integer.

    Input

    A single line with a positive integer k (1 ≤ k ≤ 10 000).

    Output

    A single number, denoting the k-th smallest perfect integer.

    Examples
    input
    1
    output
    19
    input
    2
    output
    28
    Note

    The first perfect integer is 19 and the second one is 28.

    暴力打表

    #include <bits/stdc++.h>
    
    using namespace std;
    
    bool calc(int x) {
        int sum = 0;
        while(x) {
            sum+=(x%10);
            x/=10;
        }
        return sum==10;
    }
    
    int main()
    {
        vector<int> ans;
        for(int i = 19; i < 20000000; i++) {
            if(calc(i))
                ans.push_back(i);
        }
        //printf("%d
    ",ans.size());
        int k;
        scanf("%d",&k);
        printf("%d
    ",ans[k-1]);
    
        return 0;
    }
    View Code
    C. Seat Arrangements

    Suppose that you are in a campus and have to go for classes day by day. As you may see, when you hurry to a classroom, you surprisingly find that many seats there are already occupied. Today you and your friends went for class, and found out that some of the seats were occupied.

    The classroom contains n rows of seats and there are m seats in each row. Then the classroom can be represented as an n × m matrix. The character '.' represents an empty seat, while '*' means that the seat is occupied. You need to find k consecutive empty seats in the same row or column and arrange those seats for you and your friends. Your task is to find the number of ways to arrange the seats. Two ways are considered different if sets of places that students occupy differs.

    Input

    The first line contains three positive integers n, m, k (1 ≤ n, m, k ≤ 2 000), where n, m represent the sizes of the classroom and k is the number of consecutive seats you need to find.

    Each of the next n lines contains m characters '.' or '*'. They form a matrix representing the classroom, '.' denotes an empty seat, and '*' denotes an occupied seat.

    Output

    A single number, denoting the number of ways to find k empty seats in the same row or column.

    Examples
    input
    2 3 2
    **.
    ...
    output
    3
    input
    1 2 2
    ..
    output
    1
    input
    3 3 4
    .*.
    *.*
    .*.
    output
    0
    Note

    In the first sample, there are three ways to arrange those seats. You can take the following seats for your arrangement.

    • (1, 3), (2, 3)
    • (2, 2), (2, 3)
    • (2, 1), (2, 2)

     k连坐

    做的时候把我做傻了,一步三坑。以至于我算重复了。

    1 ,行数只有一行

    2 ,k = 1

    搞得我换了两种写法。第二种好看一点。

    #include <bits/stdc++.h>
    
    using namespace std;
    
    const int maxn = 2005;
    char maps[maxn][maxn];
    
    int main()
    {
        //freopen("in.txt","r",stdin);
        int n,m,K;
        scanf("%d%d%d",&n,&m,&K);
        int ans = 0;
        for(int i = 0; i < n; i++) scanf("%s",maps[i]);
            if(K == 1) {
            for(int i = 0; i < n; i++) {
                for(int j = 0; j < m; j++) {
                    if(maps[i][j]=='.')
                        ans++;
                }
            }
            printf("%d
    ",ans);
            return 0;
        }
    
        for(int i = 0; i < n; i++) {
            for(int j = 0; j < m; j++)
            {
                if(maps[i][j]=='.') {
                    int cnt = 0;
                    int k;
                    for(k = j; k < m; k++) {
                        if(maps[i][k]=='.')
                            cnt++;
                        else break;
                    }
                    if(cnt>=K) {
                        ans = ans + cnt-K+1;
                    }
                    j = k;
                }
            }
        }
    
        if(n!=1) {
            for(int j = 0; j < m; j++) {
                for(int i = 0; i < n; i++)
                {
                    if(maps[i][j]=='.') {
                        int cnt = 0;
                        int k;
                        for(k = i; k < n; k++) {
                            if(maps[k][j]=='.')
                                cnt++;
                            else break;
                        }
                        if(cnt>=K)
                            ans=ans + cnt - K +1;
                        i = k;
                    }
                }
            }
        }
    
        printf("%d
    ",ans);
        return 0;
    }
    View Code
    #include <bits/stdc++.h>
    
    using namespace std;
    
    const int maxn = 2005;
    char maps[maxn][maxn];
    
    int main()
    {
        //freopen("in.txt","r",stdin);
        int n,m,K;
        scanf("%d%d%d",&n,&m,&K);
    
        for(int i = 0; i < n; i++) scanf("%s",maps[i]);
        
        if(K == 1) {
            int ans = 0;
            for(int i = 0; i < n; i++) {
                for(int j = 0; j < m; j++) {
                    if(maps[i][j]=='.')
                        ans++;
                }
            }
            printf("%d
    ",ans);
            return 0;
        }
        
    
        int ans = 0;
        int cnt = 0;
        int i,j;
        for(i = 0; i < n; i++)
        {
            cnt = 0;
            for(j = 0; j < m; j++)
            {
                if(maps[i][j]=='*'||maps[i][j+1]=='')
                {
                    if(maps[i][j]=='.') cnt++;
                    ans += cnt>=K ? cnt - K + 1:0;
                    cnt = 0;
                    continue;
                }
                cnt ++;
            }
        }
        if(n!=1)
        {
            for(i = 0; i < m; i++)
            {
                cnt = 0;
                for(j = 0; j < n; j++)
                {
                    if(maps[j][i]=='*'||maps[j+1][i]=='')
                    {
                        if(maps[j][i]=='.') cnt++;
                        ans += cnt>=K ? cnt - K + 1:0;
                        cnt = 0;
                        continue;
                    }
                    cnt++;
                }
            }
        }
    
        printf("%d
    ",ans);
        return 0;
    }
    View Code
    D. Substring

    You are given a graph with n nodes and m directed edges. One lowercase letter is assigned to each node. We define a path's value as the number of the most frequently occurring letter. For example, if letters on a path are "abaca", then the value of that path is 3. Your task is find a path whose value is the largest.

    Input

    The first line contains two positive integers n, m (1 ≤ n, m ≤ 300 000), denoting that the graph has n nodes and m directed edges.

    The second line contains a string s with only lowercase English letters. The i-th character is the letter assigned to the i-th node.

    Then m lines follow. Each line contains two integers x, y (1 ≤ x, y ≤ n), describing a directed edge from x to y. Note that x can be equal to y and there can be multiple edges between x and y. Also the graph can be not connected.

    Output

    Output a single line with a single integer denoting the largest value. If the value can be arbitrarily large, output -1 instead.

    Examples
    input
    5 4
    abaca
    1 2
    1 3
    3 4
    4 5
    output
    3
    input
    6 6
    xzyabc
    1 2
    3 1
    2 3
    5 4
    4 3
    6 4
    output
    -1
    input
    10 14
    xzyzyzyzqx
    1 2
    2 4
    3 5
    4 5
    2 6
    6 8
    6 5
    2 10
    3 9
    10 9
    4 6
    1 10
    2 8
    3 7
    output
    4
    Note

    In the first sample, the path with largest value is 1 → 3 → 4 → 5. The value is 3 because the letter 'a' appears 3 times.

    题意:

    给定 n 个点,m条边,每个点上都有字母,求一条路径上,最多字母的那条路径,那个字母有多少。

    我开始的思路是,先拓扑判断是否有环,然后回溯法,d[u] : u 结点出发的最优解,那么 d[u] 和 d[v] 之间转移。

    v 结点有多解,那么要根据 u 来选择其中一个,也就是说,对于每一个u的最优解,都得是一个vector类型的pair 数据。

    这样是比较麻烦的。

    看官方题解的做法:

    他的状态定义就不一样了,f[i][j] :当前顶点是 i 时,字母 j 是顶点的路径上的最优值。

    大神的代码就是厉害了,判环和求解写在一起。

    直接深搜下去,注意边界。

    然后如果有环,用特殊值标记。学习了!

    #include <bits/stdc++.h>
    
    using namespace std;
    
    const int MAXN = 300005;
    int f[MAXN][26],n,m;
    vector<int> G[MAXN];
    char s[MAXN];
    
    
    int dfs(int u,int c) {
        if(f[u][c]==-2) {
            puts("-1");
            exit(0);
        }
        if(f[u][c]!=-1) 
            return f[u][c];
        f[u][c] = -2;
        int res = 0;
        for(int i = 0; i <(int)G[u].size(); i++) {
            int v = G[u][i];
            res = max(res,dfs(v,c));
        }
        
        res += s[u]-'a'==c;
        f[u][c] = res;
        return res;
    }
    
    int main()
    {
        scanf("%d%d",&n,&m);
        scanf("%s",s+1);
        
        for(int i = 1; i<= m; i++) {
            int u,v;
            scanf("%d%d",&u,&v);
            G[u].push_back(v);
        }
        
        memset(f,-1,sizeof(f));
        int ans = 0;
        for(int i = 1; i<= n; i++)
            for(int j = 0; j <26; j++) 
                ans = max(ans,dfs(i,j));
        printf("%d
    ",ans);
        
        
        return 0;
    }
  • 相关阅读:
    spring 事务管理
    snmp4j 异步获取节点信息
    snmp4j 过滤错误的节点
    国际化支持
    通过Java反射机制获取对象的方法
    jdk中有哪些包不用自动导入
    位运算符
    spring 从入门到精通 (一)
    命令行工具nslookup查域名DNS服务器
    java/php DES/CBC/PKCS5Padding加密解密算法实现过程
  • 原文地址:https://www.cnblogs.com/TreeDream/p/8398396.html
Copyright © 2020-2023  润新知